var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState, useEffect } from "react";
import styled from "styled-components";
import { FaCheckCircle } from 'react-icons/fa';
var ReactPasswordProps = function (_a) {
    var className = _a.className, style = _a.style, rules = _a.rules, value = _a.value, valueAgain = _a.valueAgain, minLength = _a.minLength, onChange = _a.onChange, remainingProps = __rest(_a, ["className", "style", "rules", "value", "valueAgain", "minLength", "onChange"]);
    var _b = useState(false), isValid = _b[0], setIsValid = _b[1];
    var ruleDefinitions = {
        length: {
            valid: value.length >= (minLength || 100),
            message: "Devem conter entre " + minLength + " e 30 caracteres",
        },
        specialChar: {
            valid: /[~`!#$%\^&*+=\-\[\]\\';,/{}|\\":<>\?]/g.test(value),
            message: "Senha com caracteres especiais",
        },
        number: {
            valid: /\d/g.test(value),
            message: "Senha com números",
        },
        capital: {
            valid: (function () {
                var i = 0;
                if (value.length === 0) {
                    return false;
                }
                while (i < value.length) {
                    var character = value.charAt(i);
                    if (character == character.toLowerCase()) {
                        // Character is lowercase, numeric, or a symbol
                    }
                    else if (character == character.toUpperCase()) {
                        return true;
                    }
                    i++;
                }
                return false;
            })(),
            message: "A senha tem uma letra maiúscula.",
        },
        match: {
            valid: value.length > 0 && value === valueAgain,
            message: "Senhas iguais",
        },
        equalNumber: {
            valid: /^(\d)\1{10}/.test(value),
            message: "Não pode conter 3 caracteres iguais em sequência (ex:aaaa)"
        },
    };
    var enabledRules = rules.filter(function (rule) { return Boolean(ruleDefinitions[rule]); });
    useEffect(function () {
        if (enabledRules.every(function (rule) { return ruleDefinitions[rule].valid; })) {
            setIsValid(true);
        }
        else {
            setIsValid(false);
        }
    }, [value, valueAgain]);
    useEffect(function () {
        if (typeof onChange === "function") {
            onChange(isValid);
        }
    }, [isValid]);
    return (React.createElement(UL, { className: className, style: style }, enabledRules.map(function (rule) {
        var _a = ruleDefinitions[rule], message = _a.message, valid = _a.valid;
        return (React.createElement(Rule, __assign({ key: rule, valid: valid }, remainingProps), message));
    })));
};
var Rule = function (_a) {
    var valid = _a.valid, iconSize = _a.iconSize, validColor = _a.validColor, invalidColor = _a.invalidColor, children = _a.children;
    return (React.createElement(LI, { className: valid ? "valid" : "invalid" },
        valid ? (React.createElement(FaCheckCircle, { width: iconSize, height: iconSize, color: validColor })) : (React.createElement(FaCheckCircle, { width: iconSize, height: iconSize, color: "#666" })),
        React.createElement("span", null, children)));
};
var UL = styled.ul(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tmargin: 0;\n\tpadding: 0;\n"], ["\n\tmargin: 0;\n\tpadding: 0;\n"])));
var LI = styled.li(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\nmargin-left:10px;\n\tlist-style-type: none;\n\tdisplay: flex;\n\talign-items: center;\n\tmargin: 2px 0;\n\t& > span {\n\t\tpadding-top: 2px;\n\t\topacity: ", "\n\t}\n"], ["\nmargin-left:10px;\n\tlist-style-type: none;\n\tdisplay: flex;\n\talign-items: center;\n\tmargin: 2px 0;\n\t& > span {\n\t\tpadding-top: 2px;\n\t\topacity: ", "\n\t}\n"
    //const Icon = styled.svg`
    ////	margin-right: 5px;
    //`
])), function (props) { return props.className === "valid" ? 1 : 0.5; });
//const Icon = styled.svg`
////	margin-right: 5px;
//`
ReactPasswordProps.defaultProps = {
    iconSize: 12,
    validColor: "#4BCA81",
    invalidColor: "#FF0033",
};
export default ReactPasswordProps;
var templateObject_1, templateObject_2;
